const Koa = require('koa');
const app = new Koa();

// logger
app.use(async (ctx, next) => {
    try {
        await next();
    } catch (err) {
        ctx.status = 500;
        ctx.body = {
            error: err.message
        }
    }
});

app.use(async (ctx, next) => {
    await next();
    const rt = ctx.response.get('X-Response-Time');
    console.log(`${ctx.method} ${ctx.url} - ${rt}`);
});

// x-response-time
app.use(async (ctx, next) => {
    const start = Date.now();
    await next();
    const ms = Date.now() - start;
    ctx.set('X-Response-Time', `${ms}ms`);
});

// response
app.use(async ctx => {
    let Hello = 'World'

    if (ctx.query['name'] != undefined && ctx.query['name'].length) {
        Hello = ctx.query['name']
    }
    ctx.body = { Hello };
});

app.listen(3000);